/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.LoginUser;
import com.portofolio.entity.vo.LoginUserId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface RegistrasiLoginUserDao extends CrudRepository<LoginUser, LoginUserId> {

	LoginUser findOneByKdUser(Long kdUser);

	@Query(QModelAll + " and lower(model.namaUserEmail) =:namaUserEmail")
	LoginUser findOneByNamaUserEmail(@Param("namaUserEmail")String namaUserEmail);

	@Query(QModelAll + " and model.namaUserMobile =:namaUserMobile ")
	LoginUser findOneByNamaUserMobile(@Param("namaUserMobile")String namaUserMobile);

	@Query(QListAll
			+ " and (model.namaUserMobile =:noHP or lower(model.namaUserEmail) =:email)  ")
	Map<String, Object> findByUserName(@Param("noHP") String noHP, @Param("email") String email);
	
	@Query(QListAll
			+ " and model.id.kdUser =:kdUser   ")
	Map<String, Object> findOneByKodeDao(@Param("kdUser") Long kdUser );

	String QListAll = "select new map(model.kdUser as kodeUser " + ", model.namaUserMobile as namaUserMobile "
			+ ", model.namaUserEmail as namaUserEmail , model.kataSandi as kataSandi "
			+ ", model.hintKataSandi as hintKataSandi " + ", model.tglDaftar as tglDaftar "
			+ ", model.namaLengkap as namaLengkap " + ", model.tglLahir as tglLahir "
			+ ", model.jenisKelamin as jenisKelamin " + ", model.noIdentitas as noIdentitas "
			+ ", model.alamatLengkap as alamatLengkap " + ", model.imageUser as imageUser "
			+ ", model.pathFileImageUser as pathFileImageUser " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", model.version as version )" + " from MapLoginUserToPegawai m right join m.loginUser model left join m.pegawai p where  model.statusEnabled=true and (p.kdPegawaiKK is null or p.kdPegawaiKK='')";

	String QModelAll = "select model from LoginUser model where  model.statusEnabled=true ";



}
